;=========================================================================
    include \masm32\include\masm32rt.inc
;=========================================================================

;---------------------------------------------------------
; This macro more or less duplicates the functionality of
; the BASIC language TIMER function, returning the elapsed
; seconds since the performance counter started counting
; as a REAL8 value with an effective resolution of a few
; microseconds.
;---------------------------------------------------------

timer MACRO
    IFNDEF _timer_pc_frequency_
        .data
            align 8
            _timer_pc_frequency_      dq 0
            _timer_pc_count_          dq 0
            _timer_elapsed_seconds_   dq 0
            _timer_initialized_       dd 0
        .code
    ENDIF
    .IF _timer_initialized_ == 0
        invoke QueryPerformanceFrequency, ADDR _timer_pc_frequency_
        inc _timer_initialized_
    .ENDIF
    invoke QueryPerformanceCounter, ADDR _timer_pc_count_
    fild _timer_pc_count_
    fild _timer_pc_frequency_
    fdiv
    fstp _timer_elapsed_seconds_
    EXITM <_timer_elapsed_seconds_>
ENDM

;=========================================================================
    .data
        t8 REAL8 0.0
    .code
;=========================================================================

start:
;=========================================================================

    invoke Sleep, 3000

    ;----------------------------------------------------------
    ; Since our loop is calling the Sleep function 1000 times,
    ; the elapsed time per call in milliseconds will be equal
    ; to the total loop time in seconds.
    ;----------------------------------------------------------

    fld timer()
    mov ebx, 1000
    .WHILE ebx
      invoke Sleep, 1
      dec ebx
    .ENDW
    fld timer()
    fsubr
    fstp t8
    invoke crt_printf, cfm$("Sleep(1) delay  = %2.3f ms\n"), t8

    fld timer()
    mov ebx, 1000
    .WHILE ebx
      invoke Sleep, 10
      dec ebx
    .ENDW
    fld timer()
    fsubr
    fstp t8
    invoke crt_printf, cfm$("Sleep(10) delay = %2.3f ms\n\n"), t8

    inkey "Press any key to exit..."
    exit

;=========================================================================
end start
